#pragma once
#include <filesystem>
#include <string>
#include "../../YoggieEngine/src/YoggieEngine.h"

enum class ASSET_TYPE {
	Unknown = -1,
	Mesh,
	Texture,
	Material
};

class Asset {
public:
	Asset(const char* name):  name(name) {}
	virtual ASSET_TYPE GetType() { return ASSET_TYPE::Unknown; }
	const char* GetName() const { return name.c_str(); }
	bool isFolder = false ;
protected:
	std::string name;

};

class MeshAsset : Asset {
public:
	MeshAsset(YoggieEngine::Mesh mesh) : Asset("New MeshAsset"), mesh(mesh) {}
	ASSET_TYPE  GetType() override { return ASSET_TYPE::Mesh; }
private:
	YoggieEngine::Mesh& mesh;
};

class TextureAsset : Asset {
public:
	TextureAsset (YoggieEngine::Texture texture): Asset("New TextureAsset"), texture(texture) {}
	ASSET_TYPE GetType() override { return ASSET_TYPE::Texture; }
private:
	YoggieEngine::Texture& texture;
};

class MaterialAsset : Asset {
public:
	MaterialAsset ()  : Asset("New MaterialAsset"){}
	ASSET_TYPE GetType() override { return ASSET_TYPE::Material; }
private:

};